/* <INSERT COPYRIGHT & LICENSE TEXT HERE> */

#ifndef DAC80508Z_H_
#define DAC80508Z_H_

#include <stdint.h>


//**********************************************************************************
//
// Function prototypes
//
//**********************************************************************************



//**********************************************************************************
//
// Device commands
//
//**********************************************************************************



//**********************************************************************************
//
// Register definitions
//
//**********************************************************************************


/* Register 0x00 (NOOP) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                       NO OPERATION[15:0]                                                                                                                                      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* NOOP register address */
    #define NOOP_ADDRESS													((uint8_t) 0x00)

    /* NOOP register field masks */
    #define NOOP_NO OPERATION_MASK								((uint16_t) 0xFFFF)



/* Register 0x01 (DEVICE ID) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |        0        |                   RESOLUTION[2:0]                   |        1        |        0        |        0        |        0        |        0        |        0        |        1        |        1        |        1        |        0        |          VERSION ID[1:0]          |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DEVICE ID register address */
    #define DEVICE ID_ADDRESS												((uint8_t) 0x01)

    /* DEVICE ID default (reset) value */
    #define DEVICE ID_DEFAULT												((uint16_t) 0x2068)
    #define DEVICE ID_DEFAULT_MASK									((uint16_t) 0x0816)

    /* DEVICE ID register field masks */
    #define DEVICE ID_RESOLUTION_MASK								((uint16_t) 0x7000)
    #define DEVICE ID_VERSION ID_MASK								((uint16_t) 0x0003)



/* Register 0x02 (SYNC) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * | DAC7-BRDCAST-EN | DAC6-BRDCAST-EN | DAC5-BRDCAST-EN | DAC4-BRDCAST-EN | DAC3-BRDCAST-EN | DAC2-BRDCAST-EN | DAC1-BRDCAST-EN | DAC0-BRDCAST-EN |   DAC7-SYNC-EN  |   DAC6-SYNC-EN  |   DAC5-SYNC-EN  |   DAC4-SYNC-EN  |   DAC3-SYNC-EN  |   DAC2-SYNC-EN  |   DAC1-SYNC-EN  |   DAC0-SYNC-EN  |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* SYNC register address */
    #define SYNC_ADDRESS													      ((uint8_t) 0x02)

    /* SYNC default (reset) value */
    #define SYNC_DEFAULT													      ((uint16_t) 0xFF00)
    #define SYNC_DEFAULT_MASK												    ((uint16_t) 0xFF00)

    /* SYNC register field masks */
    #define SYNC_DAC7-BRDCAST-EN_MASK										((uint16_t) 0x8000)
    #define SYNC_DAC6-BRDCAST-EN_MASK										((uint16_t) 0x4000)
    #define SYNC_DAC5-BRDCAST-EN_MASK										((uint16_t) 0x2000)
    #define SYNC_DAC4-BRDCAST-EN_MASK										((uint16_t) 0x1000)
    #define SYNC_DAC3-BRDCAST-EN_MASK										((uint16_t) 0x0800)
    #define SYNC_DAC2-BRDCAST-EN_MASK										((uint16_t) 0x0400)
    #define SYNC_DAC1-BRDCAST-EN_MASK										((uint16_t) 0x0200)
    #define SYNC_DAC0-BRDCAST-EN_MASK										((uint16_t) 0x0100)
    #define SYNC_DAC7-SYNC-EN_MASK											((uint16_t) 0x0080)
    #define SYNC_DAC6-SYNC-EN_MASK											((uint16_t) 0x0040)
    #define SYNC_DAC5-SYNC-EN_MASK											((uint16_t) 0x0020)
    #define SYNC_DAC4-SYNC-EN_MASK											((uint16_t) 0x0010)
    #define SYNC_DAC3-SYNC-EN_MASK											((uint16_t) 0x0008)
    #define SYNC_DAC2-SYNC-EN_MASK											((uint16_t) 0x0004)
    #define SYNC_DAC1-SYNC-EN_MASK											((uint16_t) 0x0002)
    #define SYNC_DAC0-SYNC-EN_MASK											((uint16_t) 0x0001)



/* Register 0x03 (CONFIG) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |        0        |        0        |     ALM-SEL     |      ALM-EN     |      CRC-EN     |       FSDO      |       DSDO      |    REF-PWDWN    |    DAC7-PWDWN   |    DAC6-PWDWN   |    DAC5-PWDWN   |    DAC4-PWDWN   |    DAC3-PWDWN   |    DAC2-PWDWN   |    DAC1-PWDWN   |    DAC0-PWDWN   |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* CONFIG register address */
    #define CONFIG_ADDRESS													  ((uint8_t) 0x03)

    /* CONFIG register field masks */
    #define CONFIG_ALM-SEL_MASK												((uint16_t) 0x2000)
    #define CONFIG_ALM-EN_MASK												((uint16_t) 0x1000)
    #define CONFIG_CRC-EN_MASK												((uint16_t) 0x0800)
    #define CONFIG_FSDO_MASK												  ((uint16_t) 0x0400)
    #define CONFIG_DSDO_MASK												  ((uint16_t) 0x0200)
    #define CONFIG_REF-PWDWN_MASK											((uint16_t) 0x0100)
    #define CONFIG_DAC7-PWDWN_MASK										((uint16_t) 0x0080)
    #define CONFIG_DAC6-PWDWN_MASK										((uint16_t) 0x0040)
    #define CONFIG_DAC5-PWDWN_MASK										((uint16_t) 0x0020)
    #define CONFIG_DAC4-PWDWN_MASK										((uint16_t) 0x0010)
    #define CONFIG_DAC3-PWDWN_MASK										((uint16_t) 0x0008)
    #define CONFIG_DAC2-PWDWN_MASK										((uint16_t) 0x0004)
    #define CONFIG_DAC1-PWDWN_MASK										((uint16_t) 0x0002)
    #define CONFIG_DAC0-PWDWN_MASK										((uint16_t) 0x0001)



/* Register 0x04 (GAIN) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |        0        |        0        |        0        |        0        |        0        |        0        |        0        |     REF-DIV     |    BUFF7-GAIN   |    BUFF6-GAIN   |    BUFF5-GAIN   |    BUFF4-GAIN   |    BUFF3-GAIN   |    BUFF2-GAIN   |    BUFF1-GAIN   |    BUFF0-GAIN   |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* GAIN register address */
    #define GAIN_ADDRESS												      ((uint8_t) 0x04)

    /* GAIN register field masks */
    #define GAIN_REF-DIV_MASK												  ((uint16_t) 0x0100)
    #define GAIN_BUFF7-GAIN_MASK											((uint16_t) 0x0080)
    #define GAIN_BUFF6-GAIN_MASK											((uint16_t) 0x0040)
    #define GAIN_BUFF5-GAIN_MASK											((uint16_t) 0x0020)
    #define GAIN_BUFF4-GAIN_MASK											((uint16_t) 0x0010)
    #define GAIN_BUFF3-GAIN_MASK											((uint16_t) 0x0008)
    #define GAIN_BUFF2-GAIN_MASK											((uint16_t) 0x0004)
    #define GAIN_BUFF1-GAIN_MASK											((uint16_t) 0x0002)
    #define GAIN_BUFF0-GAIN_MASK											((uint16_t) 0x0001)



/* Register 0x05 (TRIGGER) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |       LDAC      |                          SOFT-RESET[3:0][3:0]                         |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* TRIGGER register address */
    #define TRIGGER_ADDRESS													((uint8_t) 0x05)

    /* TRIGGER register field masks */
    #define TRIGGER_LDAC_MASK												((uint16_t) 0x0010)
    #define TRIGGER_SOFT-RESET[3:0]_MASK						((uint16_t) 0x000F)



/* Register 0x06 (BRDCAST) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                       BRDCAST-DATA[15:0]                                                                                                                                      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* BRDCAST register address */
    #define BRDCAST_ADDRESS													((uint8_t) 0x06)

    /* BRDCAST register field masks */
    #define BRDCAST_BRDCAST-DATA_MASK								((uint16_t) 0xFFFF)



/* Register 0x07 (STATUS) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                 |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |        0        |    REF-ALARM    |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* STATUS register address */
    #define STATUS_ADDRESS													((uint8_t) 0x07)

    /* STATUS default (reset) value */
    #define STATUS_DEFAULT													((uint16_t) 0x0000)

    /* STATUS register field masks */
    #define STATUS_REF-ALARM_MASK										((uint16_t) 0x0001)



/* Register 0x08 (DAC-0-DATA) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                        DAC-0-DATA[15:0]                                                                                                                                       |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-0-DATA register address */
    #define DAC-0-DATA_ADDRESS												((uint8_t) 0x08)

    /* DAC-0-DATA register field masks */
    #define DAC-0-DATA_DAC-0-DATA_MASK								((uint16_t) 0xFFFF)



/* Register 0x09 (DAC-1-DATA) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                        DAC-1-DATA[15:0]                                                                                                                                       |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-1-DATA register address */
    #define DAC-1-DATA_ADDRESS												((uint8_t) 0x09)

    /* DAC-1-DATA register field masks */
    #define DAC-1-DATA_DAC-1-DATA_MASK								((uint16_t) 0xFFFF)



/* Register 0x0A (DAC-2-DATA) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                        DAC-2-DATA[15:0]                                                                                                                                       |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-2-DATA register address */
    #define DAC-2-DATA_ADDRESS												((uint8_t) 0x0A)

    /* DAC-2-DATA register field masks */
    #define DAC-2-DATA_DAC-2-DATA_MASK								((uint16_t) 0xFFFF)



/* Register 0x0B (DAC-3-DATA) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                        DAC-3-DATA[15:0]                                                                                                                                       |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-3-DATA register address */
    #define DAC-3-DATA_ADDRESS												((uint8_t) 0x0B)

    /* DAC-3-DATA register field masks */
    #define DAC-3-DATA_DAC-3-DATA_MASK								((uint16_t) 0xFFFF)



/* Register 0x0C (DAC-4-DATA) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                        DAC-4-DATA[15:0]                                                                                                                                       |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-4-DATA register address */
    #define DAC-4-DATA_ADDRESS												((uint8_t) 0x0C)

    /* DAC-4-DATA register field masks */
    #define DAC-4-DATA_DAC-4-DATA_MASK								((uint16_t) 0xFFFF)



/* Register 0x0D (DAC-5-DATA) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                        DAC-5-DATA[15:0]                                                                                                                                       |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-5-DATA register address */
    #define DAC-5-DATA_ADDRESS												((uint8_t) 0x0D)

    /* DAC-5-DATA register field masks */
    #define DAC-5-DATA_DAC-5-DATA_MASK								((uint16_t) 0xFFFF)



/* Register 0x0E (DAC-6-DATA) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                        DAC-6-DATA[15:0]                                                                                                                                       |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-6-DATA register address */
    #define DAC-6-DATA_ADDRESS												((uint8_t) 0x0E)

    /* DAC-6-DATA register field masks */
    #define DAC-6-DATA_DAC-6-DATA_MASK								((uint16_t) 0xFFFF)



/* Register 0x0F (DAC-7-DATA) definition
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15     |      Bit 14     |      Bit 13     |      Bit 12     |      Bit 11     |      Bit 10     |      Bit 9      |      Bit 8      |      Bit 7      |      Bit 6      |      Bit 5      |      Bit 4      |      Bit 3      |      Bit 2      |      Bit 1      |      Bit 0      |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                        DAC-7-DATA[15:0]                                                                                                                                       |
 * |-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-7-DATA register address */
    #define DAC-7-DATA_ADDRESS												((uint8_t) 0x0F)

    /* DAC-7-DATA register field masks */
    #define DAC-7-DATA_DAC-7-DATA_MASK								((uint16_t) 0xFFFF)



#endif /* DAC80508Z_H_ */
